2022-02-23 22:54 - Marius BĂLTEANU
Assignee: Marius BĂLTEANU % Done: 0%
Target version: 5.1.0   
Description

Using the default queue adapter (:async) in production is not recommended because the queue is stored in memory and you can

easily lose the items from the queue (https://api.rubyonrails.org/classes/ActiveJob/QueueAdapters/AsyncAdapter.html).

Since #26791, there were multiple issues reported caused by the default queue adapter (for example: #31241).

My proposal is to add the following check in Redmine information page:

 redmine_info.png 

Associated revisions

Revision 22360 - 2023-10-21 12:15 - Marius BĂLTEANU

Add check in Redmine information page if default queue adapter is used in production (#36695).

Revision 22361 - 2023-10-21 12:19 - Marius BĂLTEANU

Update translation (#36695).

Patch by Karel Pičman.

Revision 22362 - 2023-10-21 12:24 - Marius BĂLTEANU

Update locales (#36695).

Revision 22364 - 2023-10-22 10:21 - Marius BĂLTEANU

Fix condition to display active job queue check only for production environment  (#36695).

Revision 22365 - 2023-10-22 10:24 - Marius BĂLTEANU

Fix typo in default async adapter name  (#36695).

Revision 22403 - 2023-10-30 10:11 - Go MAEDA

Fix reversed display of default queue adapter check (#36695).

Revision 22404 - 2023-10-30 10:13 - Go MAEDA

Merged r22403 from trunk to 5.1-stable (#36695).

History

#1 - 2022-02-23 22:55 - Marius BĂLTEANU

Maybe the following translation is better: "Default queue adapter changed (is well suited only for dev/test)".

#2 - 2022-03-29 07:03 - Marius BĂLTEANU

- Target version set to 5.1.0

#3 - 2023-10-02 23:56 - Go MAEDA

- Target version changed from 5.1.0 to 6.0.0

#4 - 2023-10-12 08:46 - Karel Pičman
- File queue_adapter_changed.patch added

Here is a patch, that implements the requested feature.

#5 - 2023-10-16 01:47 - Mischa The Evil

Karel Pičman wrote in #note-4:

Here is a patch, that implements the requested feature.

 Thanks but FWIW: You may want to update the patch as there's a typo (text_defaut_queue_dapter_changed) included in the attached patch.

#6 - 2023-10-21 12:20 - Marius BĂLTEANU

- Status changed from New to Resolved

- Assignee set to Marius BĂLTEANU

- Target version changed from 6.0.0 to 5.1.0

- Resolution set to Fixed

Feature added in r22360. We had quite a lot of cases caused by this miss configuration, I found it useful to deliver it in 5.1.0.

#7 - 2023-10-21 12:28 - Marius BĂLTEANU

- Status changed from Resolved to Closed

#8 - 2023-10-22 08:48 - Mischa The Evil

- Status changed from Closed to Reopened

Marius BALTEANU wrote in #note-6:

Feature added in r22360. [...]

 I'm not 100% sure, but I think there's a typo included in that commit (s/:asyncs/:async/). I'm also not sure about the intention of the added

code-comment (#if Rails.env == 'production'). Is it a remnant of previous testing or was it intended to be un-commented before committing to show the

warning only in production?

#9 - 2023-10-22 10:25 - Marius BĂLTEANU

Mischa The Evil wrote in #note-8:

Marius BALTEANU wrote in #note-6:

Feature added in r22360. [...]

 I'm not 100% sure, but I think there's a typo included in that commit (s/:asyncs/:async/). I'm also not sure about the intention of the added

code-comment (#if Rails.env == 'production'). Is it a remnant of previous testing or was it intended to be un-commented before committing to

show the warning only in production?

 Thanks Mischa for review my changes, you're right on both issues. I've committed the fixes now.

#10 - 2023-10-23 04:38 - Mischa The Evil

- Status changed from Reopened to Resolved

Marius BALTEANU wrote in #note-9:

[...] I've committed the fixes now.

 Thanks!

#11 - 2023-10-23 08:35 - Marius BĂLTEANU

- Status changed from Resolved to Closed

#12 - 2023-11-01 16:46 - Jonathan Cormier
This redmine is the first thing that pops up if you search for the above warning.  It would be nice if it could link to a wiki that explains what and how to

change this so it's not using :Async

#13 - 2023-11-01 16:47 - Jonathan Cormier

If its that important i'd assume it should be mentioned in https://www.redmine.org/projects/redmine/wiki/RedmineInstall

#14 - 2023-11-01 17:40 - ashraf alzyoud

how we can resolve this ??

plz give us some information

#15 - 2023-11-01 23:15 - Mischa The Evil

Jonathan, ashraf: Redmine relies on Rails ActiveJob for email delivery since Redmine 4.0.0. This has been announced almost five years ago in 

Redmine 4.0.0, 3.4.7 and 3.3.9 released. Redmine administrators should have handled ActiveJob configuration with that release.

Given that we've seen lots of issues caused by this topic, this enhancement, that provides an admin notice, has been added. You can find more

(general) info about Rails ActiveJob (configuration) in this Rails guide.

Additionally, Marius has added an example howto in the wiki that documents the installation and configuration steps for one, widely-used, job queuing

library (Sidekiq).

Note: documentation for this topic has been part of the discussion in issue #33589.

#16 - 2023-11-02 14:24 - Jonathan Cormier

Thanks for the links Mischa.  Hopefully, it will help others who are googling the new error as well.

#17 - 2023-11-02 19:38 - Anthony Cartmell

I didn't want to install Redis for Sidekiq, so went for SuckerPunch.

1. cd   <redmine-root>

2. bundle add sucker_punch

3. cp additional_environment.rb.example additional_environment.rb (if needed)

4. vi additional_environment.rb to add config.active_job.queue_adapter = :sucker_punch

5. restart Redmine

#18 - 2023-11-02 19:42 - Jonathan Cormier

Anthony Cartmell wrote in #note-17:

I didn't want to install Redis for Sidekiq, so went for SuckerPunch.

 Note that sucker punch also only stores its jobs in memory so I'd be curious if it's any better than :Async.  I too would prefer to not run a Redis server

just for emails to work.

#19 - 2023-11-04 10:30 - Guillermo ML

Note that sucker punch also only stores its jobs in memory so I'd be curious if it's any better than :Async.  I too would prefer to not run a Redis

server just for emails to work.

 The author of sucker_punch says that at this point is very similar to AsyncAdapter and he recommends to use it with Rails.

We tried both and stick with AsyncAdapter. We thought that it was overkill to set up a Redis server just to deliver mails and AsyncAdapter works fine.

#20 - 2023-11-04 18:45 - ashraf alzyoud

Jonathan Cormier wrote in #note-16:

Thanks for the links Mischa.  Hopefully, it will help others who are googling the new error as well.

 Mischa The Evil wrote in #note-15:

Jonathan, ashraf: Redmine relies on Rails ActiveJob for email delivery since Redmine 4.0.0. This has been announced almost five years ago in 

Redmine 4.0.0, 3.4.7 and 3.3.9 released. Redmine administrators should have handled ActiveJob configuration with that release.

Given that we've seen lots of issues caused by this topic, this enhancement, that provides an admin notice, has been added. You can find more

(general) info about Rails ActiveJob (configuration) in this Rails guide.

Additionally, Marius has added an example howto in the wiki that documents the installation and configuration steps for one, widely-used, job

queuing library (Sidekiq).

Note: documentation for this topic has been part of the discussion in issue #33589.
 thx for your replay

1- im note in the example Sidekiq he only configure mailers, in my case im not using email bec im install redmine in my local network, its must

configure or no?

2- can i use another queue mailer??

Configure Sidekiq

Create config/sidekiq.yml file inside Redmine directory and set the queues

---

:queues:

  - mailers

Files

redmine_info.png 134 KB 2022-02-23 Marius BĂLTEANU

queue_adapter_changed.patch 26.7 KB 2023-10-12 Karel Pičman

Powered by TCPDF (www.tcpdf.org)

2025-08-23 4/4

http://www.tcpdf.org

